/*********************
 *
 * AnExperiment.h
 *
 * This is the experimental analysis module header file.
 *
 * 19-3-93 L.P.O'Mard
 *
 *********************/

#ifndef	_ANEXPERIMENT_H
#define _ANEXPERIMENT_H	1

/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#define ANALYSIS_FIRST_INTENSITY_GUESS 0.0	/* Initial threshold intensity. */
#define MAXIMUM_THRESHOLD_LOOP	100		/* - FindThresholdIntensity routine. */
    
/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN	CalcACF_ExpAnalysis( EarObjectPtr data, double timeOffset,
		  double timeConstant, double period );

double	CalcSynchIndex_ExpAnalysis( EarObjectPtr data, double pHBinWidth,
		  double pHPeriod, double pHOffset );

BOOLEAN	CalcPH_ExpAnalysis( EarObjectPtr data, double binWidth, double period,
		  double offset );

BOOLEAN	CalcPSTH_ExpAnalysis( EarObjectPtr data, double binWidth );

double	CalcQValue_ExpAnalysis( EarObjectPtr (* RunModel)(void),
		  BOOLEAN (* SetStimulusFreq)(double), double centreFreq,
		  double variationFromCF, double dBDownDiff,
		  double initialFreqIncrement, double accuracy, double calcOffset );

BOOLEAN	CalcOnSetPeakRates_ExpAnalysis( double onsetPeakRate[],
		  SignalDataPtr theSignal, double binWidth, double timeRange );

double	FindThresholdIntensity_ExpAnalysis( EarObjectPtr (* RunModel)(void),
		  BOOLEAN (* SetIntensity)(double), double targetThreshold,
		  double targetAccuracy, double calcOffset, BOOLEAN *firstPass );

#endif
