/*********************
 *
 * AnGeneral.h
 *
 * This is the general analysis module header file.
 *
 * 19-3-93 L.P.O'Mard
 *
 *********************/

#ifndef	_ANGENERAL_H
#define _ANGENERAL_H	1

/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#define	ANALYSIS_SINGLE_CHANNEL	1		/* For single channel routines. */
#define	ANALYSIS_CHANNEL		0		/* For single channel routines. */
#define ANALYSIS_FIRST_INTENSITY_GUESS 0.0	/* Initial threshold intensity. */
#define MAXIMUM_THRESHOLD_LOOP	100		/* - FindThresholdIntensity routine. */
    
/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN	AveChannels_GenAnalysis(EarObjectPtr data);

BOOLEAN	CalcAverages_GenAnalysis(double average[], SignalDataPtr theSignal,
		  double startPeriod, double endPeriod);
		  
BOOLEAN	CalcHalfCompAverages_GenAnalysis(double average[], SignalDataPtr theSignal,
		  double startPeriod, double endPeriod);

BOOLEAN	CalcHalfRareAverages_GenAnalysis(double average[], SignalDataPtr theSignal,
		  double startPeriod, double endPeriod);

BOOLEAN	CalcIntensities_GenAnalysis(double intensityValue[], SignalDataPtr theSignal,
		  double offsetTime);

void	FindPeakPositions_GenAnalysis(double firstPeaks[], int peakNumber,
		  SignalDataPtr theSignal);

BOOLEAN	FindNextMinIndexes_GenAnalysis(ChanLen index[], SignalDataPtr theSignal,
		  double offset);

BOOLEAN	FindNextPeakIndexes_GenAnalysis(ChanLen index[],SignalDataPtr theSignal,
		  double offset);

#endif
