/*****************
 *
 * FiParFile.h
 *
 * This header file is for the ParFile module which contains the parameter file
 * routines for the LUTEar Core Routines Library.
 *
 *****************/

#ifndef	_FIPARFILE_H
#define _FIPARFILE_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#define FORMAT_DELIMITERS		" ,\t"		/* Characters to separate
											 * formatting commands. */
											 
/******************************************************************************/
/*************************** Type Definitions *********************************/
/******************************************************************************/

typedef struct {
	
	BOOLEAN	diagnosticsFlag;	/* Set to TRUE to print diagnostics. */
	int		parLineCount;	/*  A record of the parameter file lines read. */
	
} ParFile;

/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/

extern ParFile	*parFile; 

/******************************************************************************/
/*************************** Subroutine declarations **************************/
/******************************************************************************/ 

BOOLEAN	CheckInit_ParFile(void);

BOOLEAN	CommentOrBlankLine_ParFile(char *line);

BOOLEAN	Free_ParFile(void);

char	*GetLine_ParFile(char *line, int maxChars, FILE *fp);

BOOLEAN	GetPars_ParFile(FILE *fp, char *fmt, ...);

char	IdentifyFormat_ParFile(char *fmt);

BOOLEAN	Init_ParFile(void);

#endif
