/*******
 *
 * SignalData.h
 *
 * This header file contains the SignalData class.
 *
 * by Lowel O'Mard 17-2-93.
 *
 * 3-3-92 This file has been converted to ANSI C...LPO.
 *
 ********/

#ifndef	_SIGNALDATA_H
#define _SIGNALDATA_H	1

/******************************************************************************/
/*************************** Constant definitions *****************************/
/******************************************************************************/

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef struct {

	BOOLEAN	dtFlag;			/* Set flags to guard against errors */
	BOOLEAN	lengthFlag;		/* and horrible bugs. */
	BOOLEAN	rampFlag;		/* Checks that signals have been ramped. */
	int		numChannels;	/* No. of channels of data in array 'dataPoint' */
	ChanLen	length;			/* The length of the signal store in datapoint */
	double	dt;				/* Sampling interval = 1/(Frame rate) */
	ChanData	*channel[MAX_CHANNELS];			/* Signal data channels */
		
} SignalData, *SignalDataPtr;

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN	AddScaledData_SignalData(SignalDataPtr a, SignalDataPtr b,
		  double scale[]);

BOOLEAN	AddScaledData_SignalData_Single(SignalDataPtr a, SignalDataPtr b,
		  double scale);
		  
double	GetDuration_SignalData(SignalDataPtr theSignal);

BOOLEAN	CheckInit_SignalData(SignalDataPtr theSignal, char *callingFunction);

BOOLEAN	CheckPars_SignalData(SignalDataPtr theSignal);

BOOLEAN	CheckRamp_SignalData(SignalDataPtr theSignal);

void	Free_SignalData(SignalDataPtr *theData);

BOOLEAN	GaindB_SignalData(SignalDataPtr d, double gaindB);

SignalDataPtr	Init_SignalData(char *callingFunctionName);

BOOLEAN	InitChannel_SignalData(SignalDataPtr theData);
	
SignalDataPtr	InitCopy_SignalData(SignalDataPtr original);

BOOLEAN	Scale_SignalData(SignalDataPtr d, double multiplier);

BOOLEAN	SameType_SignalData_NoDiagnostics(SignalDataPtr a, SignalDataPtr b);
 
BOOLEAN	OutputToFile_SignalData(char *fileName, SignalDataPtr theData);

BOOLEAN	SameType_SignalData(SignalDataPtr a, SignalDataPtr b);

BOOLEAN	SetChannelsFromSignal_SignalData(SignalDataPtr theSignal,
		  SignalDataPtr supplier);

void	SetLength_SignalData(SignalDataPtr theData, ChanLen theLength);

void	SetSamplingInterval_SignalData(SignalDataPtr theData,
		  double theSamplingInterval);
	
#endif
