/*******
 *
 * MoDendrite.h
 *
 * This header file contains the definitions for the dendrite filter module.
 * *
 ********/

#ifndef	_MODENDRITE_H
#define _MODENDRITE_H	1

/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/ 

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef struct {
	
	BOOLEAN	cutOffFrequencyFlag, signalMultiplierFlag;
	double	cutOffFrequency, signalMultiplier;
			
} Dendrite;

/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/

extern	Dendrite	dendrite;

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN	CheckPars_Neuron_DendriteLP(void);

void	PrintPars_Neuron_DendriteLP(void);

BOOLEAN	ReadPars_Neuron_DendriteLP(char *fileName);

BOOLEAN	RunModel_Neuron_DendriteLP(EarObjectPtr data);

BOOLEAN	SetCutOffFrequency_Neuron_DendriteLP(double theCutOffFrequency);

BOOLEAN	SetPars_Neuron_DendriteLP(double theLowerCutOffFreq,
		  double theUpperCutOffFreq);
 
BOOLEAN	SetSignalMultiplier_Neuron_DendriteLP(double theUpperCutOffFreq);

#endif
