/*******
 *
 * MoPreEmph.h
 *
 * This header file contains the definitions for the pre-emphasis filter module.
 *
 * by Lowel O'Mard 11-3-93.
 *
 ********/

#ifndef	_MOPREMPH_H
#define _MOPREMPH_H	1

/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/ 

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/ 

typedef struct {
	
	BOOLEAN	upperCutOffFreqFlag, lowerCutOffFreqFlag;
	double	upperCutOffFreq, lowerCutOffFreq;

} PreEmphasis;

/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/ 

extern	PreEmphasis	preEmphasis;

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/ 

BOOLEAN	CheckPars_PreEmphasis_BandPass(void);

void	PrintPars_PreEmphasis_BandPass(void);

BOOLEAN	ReadPars_PreEmphasis_BandPass(char *fileName);

BOOLEAN	RunModel_PreEmphasis_BandPass(EarObjectPtr data);

BOOLEAN	SetLowerCutOffFreq_PreEmphasis_BandPass(double theLowerCutOffFreq);

BOOLEAN	SetPars_PreEmphasis_BandPass(double theLowerCutOffFreq,
		  double theUpperCutOffFreq);

BOOLEAN	SetUpperCutOffFreq_PreEmphasis_BandPass(double theUpperCutOffFreq);

#endif
