/*******
 *
 * MoSpikeGen.h
 *
 * This header file contains the model for the post synaptic firing module.
 *
 * by Lowel O'Mard 18-2-93.
 *
 ********/

#ifndef	_MOSPIKEGEN_H
#define _MOSPIKEGEN_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#define PS_REFRACTORY_PERIOD	1.0E-3		/* Default value in seconds. */

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef struct {

 	BOOLEAN	refractoryPeriodFlag, numberOfRunsFlag, ranSeedFlag;
	long	ranSeed;			/* seed for the random number generator. */
	int		numberOfRuns;		/* No. of repeated runs for process. */
	double	refractoryPeriod;	/* The time during which spikes cannot occur */

} SpikeGen;

/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/

extern	SpikeGen	spikeGen;

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN	CheckPars_AuditoryN_SpikeGen(void);

void	 PrintPars_AuditoryN_SpikeGen(void);

BOOLEAN	ReadPars_AuditoryN_SpikeGen(char *fileName);

BOOLEAN	RunModel_AuditoryN_SpikeGen(EarObjectPtr data);

BOOLEAN	SetNumberOfRuns_AuditoryN_SpikeGen(int theNumberOfRuns);

BOOLEAN	SetPars_AuditoryN_SpikeGen(int theNumbrOfRuns, long theRanSeed,
		  double theRefractoryPeriod);

BOOLEAN	SetRanSeed_AuditoryN_SpikeGen(long theRanSeed);

BOOLEAN	SetRefractoryPeriod_AuditoryN_SpikeGen(double theRefractoryPeriod);

BOOLEAN	SetNumberOfRuns_AuditoryN_SpikeGen(int theNumberOfRuns);

#endif
