/*******
 *
 * StAMTone.h
 *
 * This header file contains the AMTone stimulus generation paradigm.
 *
 * by Lowel O'Mard 18-2-93.
 *
 ********/

#ifndef	_STAMTONE_H
#define _STAMTONE_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/ 

#define	AM_TONE_NUM_CHANNELS		1		/* No. of stimulus channels to
											 * initialise. */

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef struct {

	BOOLEAN	carrierFrequencyFlag, modulationFrequencyFlag;
	BOOLEAN percentAM_Flag, durationFlag, dtFlag;
	BOOLEAN	intensityFlag;
	double	carrierFrequency, modulationFrequency;
	double  percentAM, intensity;
	double	duration, dt;
	

} AMTone;
	
/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/

extern	AMTone	aMTone;

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN	CheckPars_AMTone(void);

BOOLEAN	GenerateSignal_AMTone(EarObjectPtr theObject);

void	PrintPars_AMTone(void);

BOOLEAN	ReadPars_AMTone(char *fileName);

BOOLEAN	SetCarrierFrequency_AMTone(double theCarrierFrequency);

BOOLEAN	SetDuration_AMTone(double theDuration);

BOOLEAN	SetIntensity_AMTone(double theIntensity);

BOOLEAN	SetModulationFrequency_AMTone(double theModulationFrequency);

BOOLEAN	SetPars_AMTone(double theCarrierFrequency, double theModulationFrequency,
		  double thePercentAM, double theIntensity, double theDuration,
		  double theSamplingInterval);

BOOLEAN	SetPercentAM_AMTone(double thePercentAM);

BOOLEAN	SetSamplingInterval_AMTone(double theSamplingInterval);

#endif
