/*******
 *
 * StBPTone.h
 *
 * This header file contains the MPureTone data structure.
 *
 * by Lowel O'Mard 18-2-93.
 *
 * 3-3-92 This file has been converted to ANSI C...LPO.
 *
 ********/

#ifndef	_STBPTONE_H
#define _STBPTONE_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#define	BINAURAL_PTONE_CHANNELS	2	/* No. of channels for binaural signal. */
#define	LEFT_BINAURAL_PTONE		0 
#define	RIGHT_BINAURAL_PTONE	1

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

/*
 * Note that the pointers do not require flags, as they are set to NULL if
 * they have not been set.  This also applies to integers which are initialised
 * to zero.
 */

typedef struct {

	BOOLEAN	frequencyFlag[2], intensityFlag[2], phaseDifferenceFlag;
	BOOLEAN	durationFlag, dtFlag;
	double	frequency[2], intensity[2];
	double	phaseDifference, duration, dt;

} BPureTone;
	
/********************************* External Variables *************************/

extern	BPureTone	bPureTone;

/********************************* Function Prototypes ************************/

BOOLEAN	CheckPars_PureTone_Binaural(void);

BOOLEAN	GenerateSignal_PureTone_Binaural(EarObjectPtr theObject);

void	PrintPars_PureTone_Binaural(void);

BOOLEAN	ReadPars_PureTone_Binaural(char *fileName);

BOOLEAN	SetDuration_PureTone_Binaural(double theDuration);

BOOLEAN	SetIndividualFreq_PureTone_Binaural(int channel, double theFrequency);

BOOLEAN	SetIndividualIntensity_PureTone_Binaural(int channel,
		  double theIntensity);

BOOLEAN	SetPars_PureTone_Binaural(double leftFrequency, double rightFrequency,
		  double leftIntensity, double rightIntensity, double phaseDifference,
		  double theDuration, double theSamplingInterval);
		  
BOOLEAN	SetPhaseDifference_PureTone_Binaural(double thePhaseDifference);

BOOLEAN	SetSamplingInterval_PureTone_Binaural(double theSamplingInterval);

#endif
