/*******
 *
 * StClick.h
 *
 * This header file contains the Click stimulus generation routines.
 *
 * by Lowel O'Mard 18-2-93.
 *
 * 3-3-92 This file has been converted to ANSI C...LPO.
 *
********/

#ifndef	_STCLICK_H
#define _STCLICK_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef struct {

	BOOLEAN	clickTimeFlag, intensityFlag, durationFlag, dtFlag;
	double	clickTime, intensity;
	double	duration, dt;

} Click;

/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/

extern	Click	click;

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN	CheckPars_Click(void);

BOOLEAN	GenerateSignal_Click(EarObjectPtr data);

void	PrintPars_Click(void);

BOOLEAN	ReadPars_Click(char *fileName);

BOOLEAN	SetClickTime_Click(double theClickTime);

BOOLEAN	SetDuration_Click(double theDuration);

BOOLEAN	SetIntensity_Click(double theIntensity);

BOOLEAN	SetPars_Click(double theClickTime, double theIntensity,
		  double theDuration, double theSamplingInterval);
		  
BOOLEAN	SetSamplingInterval_Click(double theSamplingInterval);

#endif
