/*******
 *
 * StMPPTone.h
 *
 * This header file contains the Silence Pure-Tone signal generation paradigm.
 * by Lowel O'Mard 18-2-93.
 *
 * 3-3-92 This file has been converted to ANSI C...LPO.
 *
 ********/

#ifndef	_STMPPTONE_H
#define _STMPPTONE_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#define	PURE_TONE_3_NUM_CHANNELS	1		/* No. of stimulus channels to
											 * initialise. */

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef struct {

	BOOLEAN	intensityFlag, durationFlag, dtFlag;
	BOOLEAN	beginSilenceFlag, pulseDurationFlag;
	BOOLEAN	repetitionPeriodFlag, numPulsesFlag;
	int		numPulses;
	double	intensity, duration, dt;
	double	beginSilence, pulseDuration, repetitionPeriod;
	double	*frequencies;
	
} PureTone4;
	
/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/

extern	PureTone4	pureTone4;

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN	CheckPars_PureTone_MultiPulse(void);

BOOLEAN	GenerateSignal_PureTone_MultiPulse(EarObjectPtr theObject);

double	GetIndividualFreq_PureTone_MultiPulse(int index);

void	PrintPars_PureTone_MultiPulse(void);

BOOLEAN	ReadPars_PureTone_MultiPulse(char *fileName);

BOOLEAN	SetBeginSilence_PureTone_MultiPulse(double theBeginSilence);

BOOLEAN	SetDuration_PureTone_MultiPulse(double theDuration);

BOOLEAN	SetIntensity_PureTone_MultiPulse(double theIntensity);

BOOLEAN	SetIndividualFreq_PureTone_MultiPulse(int theIndex, double theFreq);
		  
BOOLEAN	SetFrequencies_PureTone_MultiPulse(double *theFrequencies);

BOOLEAN	SetNumPulses_PureTone_MultiPulse(int theNumPulses);

BOOLEAN	SetPars_PureTone_MultiPulse(int theNumPulses, double theIntensity,
		  double *theFrequencies, double theDuration,
		  double theSamplingInterval, double theBeginSilence,
		  double thePulseDuration, double theRepetitionPeriod);
		  
BOOLEAN	SetPulseDuration_PureTone_MultiPulse(double thePulseDuration);

BOOLEAN	SetRepetitionPeriod_PureTone_MultiPulse(double theRepetitionPeriod);

BOOLEAN	SetSamplingInterval_PureTone_MultiPulse(double theSamplingInterval);

#endif
