/*******
 *
 * StMPTone.h
 *
 * This header file contains the MPureTone data structure.
 *
 * by Lowel O'Mard 18-2-93.
 *
 * 3-3-92 This file has been converted to ANSI C...LPO.
 *
 ********/

#ifndef	_STMPTONE_H
#define _STMPTONE_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#define	PURE_TONE_NUM_CHANNELS		1		/* No. of stimulus channels to
											 * initialise. */

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

/*
 * Note that the pointers do not require flags, as they are set to NULL if
 * they have not been set.  This also applies to integers which are initialised
 * to zero.
 */

typedef struct {

	BOOLEAN	numPTonesFlag, durationFlag, dtFlag;
	int		numPTones;
	double	duration, dt;
	double	*intensities, *frequencies, *phases;

} MPureTone;
	
/********************************* External Variables *************************/

extern	MPureTone	mPureTone;

/********************************* Function Prototypes ************************/

BOOLEAN	CheckPars_PureTone_Multi(void);

BOOLEAN	GenerateSignal_PureTone_Multi(EarObjectPtr theObject);

double	GetIndividualFreq_PureTone_Multi(int index);

double	GetIndividualIntensity_PureTone_Multi(int index);

void	PrintPars_PureTone_Multi(void);

BOOLEAN	ReadPars_PureTone_Multi(char *fileName);

BOOLEAN	SetDuration_PureTone_Multi(double theDuration);

BOOLEAN	SetFrequencies_PureTone_Multi(double *theFrequencies);

BOOLEAN	SetIndividualFreq_PureTone_Multi(int theIndex, double theFrequency);

BOOLEAN	SetIndividualIntensity_PureTone_Multi(int theIndex,
		  double theIntensity);

BOOLEAN	SetIndividualPhase_PureTone_Multi(int theIndex, double thePhase);

BOOLEAN	SetIntensities_PureTone_Multi(double *theIntensities);

BOOLEAN	SetNumPTones_PureTone_Multi(int theNumPTones);

BOOLEAN	SetPhases_PureTone_Multi(double *thePhases);

BOOLEAN	SetPars_PureTone_Multi(int theNumPTones, double *theFrequencies,
		  double *theIntensities, double *thePhases, double theDuration,
		  double theSamplingInterval);
		  
BOOLEAN	SetSamplingInterval_PureTone_Multi(double theSamplingInterval);

#endif
