/*******
 *
 * StPTone.h
 *
 * This header file contains the PureTone class, which is a sub-class of the
 * GenParadgm class.
 *
 * by Lowel O'Mard 18-2-93.
 *
 * 3-3-92 This file has been converted to ANSI C...LPO.
 *
 ********/

#ifndef	_STPTONE_H
#define _STPTONE_H	1
 
/******************************************************************************/ 
/*************************** Constant Definitions *****************************/ 
/******************************************************************************/ 

#define	PURE_TONE_NUM_CHANNELS		1		/* No. of stimulus channels to
											 * initialise. */

/******************************************************************************/ 
/*************************** Type definitions *********************************/ 
/******************************************************************************/ 

typedef struct {

	BOOLEAN	frequencyFlag, durationFlag, dtFlag;
	BOOLEAN	intensityFlag;
	double	frequency, intensity;
	double	duration, dt;
	
} PureTone;
	
/********************************* External Variables ***********************************/

extern	PureTone	pureTone;

/********************************* Function Prototypes **********************************/

BOOLEAN	CheckPars_PureTone(void);

BOOLEAN	GenerateSignal_PureTone(EarObjectPtr theObject);

void	PrintPars_PureTone(void);

BOOLEAN	ReadPars_PureTone(char *fileName);

BOOLEAN	SetDuration_PureTone(double theDuration);

BOOLEAN	SetFrequency_PureTone(double theFrequency);

BOOLEAN	SetIntensity_PureTone(double theIntensity);

BOOLEAN	SetPars_PureTone(double theFrequency, double theIntensity,
		  double theDuration, double theSamplingInterval);
		  
BOOLEAN	SetSamplingInterval_PureTone(double theSamplingInterval);

#endif
