/*******
 *
 * StPTone2.h
 *
 * This header file contains the Silence Pure-Tone signal generation paradigm.
 * by Lowel O'Mard 18-2-93.
 *
 * 3-3-92 This file has been converted to ANSI C...LPO.
 *
 ********/

#ifndef	_STPTONE2_H
#define _STPTONE2_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#define	PURE_TONE_2_NUM_CHANNELS	1		/* No. of stimulus channels to
											 * initialise. */

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef struct {

	BOOLEAN	frequencyFlag, durationFlag, dtFlag;
	BOOLEAN	intensityFlag, beginSilenceFlag, endSilenceFlag;
	double	frequency, intensity;
	double	duration, dt;
	double	beginSilence, endSilence;
	
} PureTone2;
	
/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/

extern	PureTone2	pureTone2;

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN	CheckPars_PureTone_2(void);

BOOLEAN	GenerateSignal_PureTone_2(EarObjectPtr theObject);

void	PrintPars_PureTone_2(void);

BOOLEAN	ReadPars_PureTone_2(char *fileName);

BOOLEAN	SetBeginSilence_PureTone_2(double theBeginSilence);

BOOLEAN	SetDuration_PureTone_2(double theDuration);

BOOLEAN	SetEndSilence_PureTone_2(double theEndSilence);

BOOLEAN	SetFrequency_PureTone_2(double theFrequency);

BOOLEAN	SetIntensity_PureTone_2(double theIntensity);

BOOLEAN	SetPars_PureTone_2(double theFrequency, double theIntensity,
		  double theDuration, double theSamplingInterval, double theBeginSilence,
		  double theEndSilence);
		  
BOOLEAN	SetSamplingInterval_PureTone_2(double theSamplingInterval);

#endif
