/*******
 *
 * StStepFun.h
 *
 * This header file contains the step function signal generation paradigm.
 * by Lowel O'Mard 18-2-93.
 *
 * 3-3-92 This file has been converted to ANSI C...LPO.
 *
 ********/

#ifndef	_STSTEPFUN_H
#define _STSTEPFUN_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/ 

#define	PURE_TONE_2_NUM_CHANNELS	1		/* No. of stimulus channels to
											 * initialise. */

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/ 

typedef struct {

	BOOLEAN	durationFlag, dtFlag;
	BOOLEAN	amplitudeFlag, beginSilenceFlag, endSilenceFlag;
	double	amplitude;		/* Arbitary units. */
	double	duration, dt;
	double	beginSilence, endSilence;
	
} StepFunction;
	
/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/ 

extern	StepFunction	stepFunction;

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/ 

BOOLEAN	CheckPars_StepFunction(void);

BOOLEAN	GenerateSignal_StepFunction(EarObjectPtr theObject);

void	PrintPars_StepFunction(void);

BOOLEAN	ReadPars_StepFunction(char *fileName);

BOOLEAN	SetAmplitude_StepFunction(double theAmplitude);

BOOLEAN	SetBeginSilence_StepFunction(double theBeginSilence);

BOOLEAN	SetDuration_StepFunction(double theDuration);

BOOLEAN	SetEndSilence_StepFunction(double theEndSilence);

BOOLEAN	SetPars_StepFunction(double theAmplitude, double theDuration,
		  double theSamplingInterval, double theBeginSilence,
		  double theEndSilence);
		  
BOOLEAN	SetSamplingInterval_StepFunction(double theSamplingInterval);

#endif
