/**************
 *
 * UtCFList.h
 *
 * This is the header file for the centre frequency management routines.
 *
 **************/

#ifndef	_UTCFLIST_H
#define _UTCFLIST_H	1
 
/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#ifndef USE_CFLIST
#	define	USE_CFLIST		-1		/* Tells setpars function to expect a
									 * CFList. */
#endif
#define	CFLIST_SINGLE_MODE	0		/* Single centre frequency mode */
#define	CFLIST_ERB_MODE		1		/* Freqs. equally spaced on ERB scale*/
#define	CFLIST_LOG_MODE		2		/* Freqs. spaced on a log10 scale*/

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef struct {

	double	channel[MAX_CHANNELS];
	int		numChannels;
	int		mode;					/* Set by the generation routines. */

} CFList, *CFListPtr;

/******************************************************************************/
/*************************** External Variables *******************************/
/******************************************************************************/

extern char	*modeCFList[];

/******************************************************************************/
/*************************** Function Prototypes ******************************/
/******************************************************************************/

BOOLEAN		CheckInit_CFList(CFList *theCFList, char *callingFunction);

BOOLEAN		CheckPars_CFList(CFList *theCFList);

CFListPtr	GenerateERB_CFList(double minCF, double maxCF, double ERBDensity);

CFListPtr	GenerateLog_CFList(double minCF, double maxCF, int numberOfCFs);

CFListPtr	Init_CFList(char *callingFunctionName);

int			Mode_CFList(char *modeName);

CFListPtr	Read_CFList(FILE *fp, char *modeName);

#endif
