/*
 *  UtCmplxm.h
 *
 *  From:-
 *
 *	CMPLXMTH.C: routines to handle Complex numbers in C.
 *	M.A.Stone, Cambridge, Sept 1992.
 *	23-02-93 L.P.O'Mard: These routines have been incorporated into the LUTEar
 *  Core Routines Library.
 *
 */

#ifndef	_UTCMPLXM_H
#define _UTCMPLXM_H	1

/******************************************************************************/ 
/*************************** Constant Definitions *****************************/ 
/******************************************************************************/ 

#ifndef M_PI
#define M_PI		3.1415926535897932
#endif
#define TWOPI		(2.0 * M_PI)
#define	PI_BY_2		(M_PI / 2.0)
#define	SCALE_RADIANS_TO_DEGREES		(360.0 / TWOPI)

#ifndef FALSE
#	define	FALSE		0
#	define	TRUE		0xFFFF
#endif

/******************************************************************************/ 
/*************************** Type Definitions *********************************/ 
/******************************************************************************/ 

#ifndef	BOOLEAN_ALGEBRA 
#	define BOOLEAN_ALGEBRA
	typedef	int		BOOLEAN;
#endif

typedef struct {

	double	re, im;
	
} Complex, *ComplexPtr;

/******************************************************************************/ 
/*************************** Function Prototypes ******************************/ 
/******************************************************************************/ 

void	Add_CmplxM(ComplexPtr a, ComplexPtr b, ComplexPtr c);

void	Convert_CmplxM(ComplexPtr a, ComplexPtr b);	/* .re has magnit.,
												 * .im has tan(theta) */

void	Copy_CmplxM(ComplexPtr a,ComplexPtr b); /*move contents of a to b */

int		Div_CmplxM(ComplexPtr a, ComplexPtr b, ComplexPtr c);

void	Subt_CmplxM(ComplexPtr a, ComplexPtr b, ComplexPtr c);

double	Modulus_CmplxM(ComplexPtr z);

void	Mult_CmplxM(ComplexPtr a, ComplexPtr b, ComplexPtr c);

double	Phase_CmplxM(ComplexPtr z);

void	Power_CmplxM(ComplexPtr a, double n);

#endif
