/**************
 *
 * UtERB.h
 *
 * Equivalent rectangular bandwidth (ERB) freqency functions.
 * These functions uses the Glasberg & Moore 1990 formulae.
 *
 **************/

#ifndef	_UTERB_H
#define _UTERB_H	1
 
/******************************************************************************/ 
/*************************** Constant Definitions *****************************/ 
/******************************************************************************/ 

#define	K1_ERB		24.7		/* k1 constant. */
#define K2_ERB		4.37e-3		/* K2 constant, frequency in Hz. */
#define K3_ERB		21.4		/* K3 constant, for ERB rate calc. */

/******************************************************************************/ 
/*************************** Function Prototypes ******************************/ 
/******************************************************************************/ 

/* formulae.c calls: ERB as a function of frequency etc, Glasberg and Moore 1990
 * versions only.
 */
 
double	ERBFromF_ERB(double x);

double	FFromERB_ERB(double x);

double	ERBRateFromF_ERB(double theFrequency);

double	FFromERBRate_ERB(double theERBRate);

#endif
