/***********************
 *
 * UtUIEEEFloat.h
 *
 * 3-9-93 L.P.O'Mard: Converted to ANSI C format, constructed header file
 *   and defined the int32 type which is used by the respective reading routines.
 *
 ***********************/

#ifndef	_UTUIEEEFLOAT_H
#define _UTUIEEEFLOAT_H	1
 
/* Copyright (C) 1988-1991 Apple Computer, Inc. 
* All Rights Reserved.
*
* Warranty Information
* Even though Apple has reviewed this software, Apple makes no warranty 
* or representation, either express or implied, with respect to this 
* software, its quality, accuracy, merchantability, or fitness for a 
* particular purpose. As a result, this software is provided "as is," 
* and you, its user, are assuming the entire risk as to its quality 
* and accuracy.
*
* This code may be used and freely distributed as long as it includes 
* this copyright notice and the warranty information. 
*
* Machine-independent I/O routines for IEEE floating-point numbers. 
*
* NaN's and infinities are converted to HUGE_VAL or HUGE, which 
* happens to be infinity on IEEE machines. Unfortunately, it is 
* impossible to preserve NaN's in a machine-independent way. 
* Infinities are, however, preserved on IEEE machines. 
*
* These routines have been tested on the following machines: 
*	Apple Macintosh, MPW 3.1 C compiler
*	Apple Macintosh, THINK C compiler
*	Silicon Graphics IRIS, MIPS compiler
*	Cray X/MP and Y/MP
*	Digital Equipment VAX
*	Sequent Balance (Multiprocesor 386)
*	NeXT
*
*
* Implemented by Malcolm Slaney and Ken Turkowski. 
*
* Malcolm Slaney contributions during 1988-1990 include big- and little- 
* endian file I/O, conversion to and from Motorola's extended 80-bit 
* floating-point format, and conversions to and from IEEE single- 
* precision floating-point format.
*
* In 1991, Ken Turkowski implemented the conversions to and from 
* IEEE double-precision format, added more precision to the extended 
* conversions, and accommodated conversions involving +/- infinity, 
* NaN's, and denormalized numbers.
* $Header: /u/eng/malcolm/Speech/NewMacEar/RCS/UIeeeFloat.c,v 1.1 1992/12/11 18:16:05 malcolm Exp malcolm $ *
* $Log: UIeeeFloat.c,v $
* Revision 1.1 1992/12/11 18:16:05 malcolm * Initial revision
*
*/

/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef	double	DefDouble;

typedef	double	Double;

typedef	float	Single;

/******************************************************************************/
/*************************** External variables *******************************/
/******************************************************************************/

/******************************************************************************/
/*************************** Subroutine declarations **************************/
/******************************************************************************/

void		Bytes2Hex(register char *bytes, char *hex, register int nBytes);

void		ConvertToIeeeDouble(DefDouble num, char *bytes);

void		ConvertToIeeeExtended(DefDouble num, char *bytes);

void		ConvertToIeeeSingle(DefDouble num, char *bytes);

void		Hex2Bytes(register char *hex, char *bytes);

void		MaybeSwapBytes(char *bytes, int nBytes);

void		SignalFPE(int i);

void		TestFromIeeeDouble(char *hex);

void		TestFromIeeeExtended(char *hex);

void		TestFromIeeeSingle(char *hex);

void		TestToIeeeDouble(DefDouble f);

void		TestToIeeeExtended(DefDouble f);

void		TestToIeeeSingle(DefDouble f);

int			GetHexSymbol(register int x);

int			GetHexValue(register int x);

float		MachineIEEESingle(char *bytes);

double		MachineIEEEDouble(char *bytes);

DefDouble	ConvertFromIeeeDouble(char *bytes);

DefDouble	ConvertFromIeeeExtended(char *bytes);

DefDouble	ConvertFromIeeeSingle(char *bytes);

#endif
