/**********************
 *
 * UtUPortableIO.h
 *
 **********************/

#ifndef	_UTUPORTABLEIO_H
#define _UtUPortableIO_H	1

/*
*				Apple Cochlear Models
*	 			 Malcolm Slaney
*				Advanced Technology Group
*				Apple Computer, Inc.
*				 malcolm@apple.com
*					1990-1993
*
*	Warranty Information
*	Even though Apple has reviewed this software, Apple makes no warranty 
*
	or representation, either express or implied, with respect to this 
	*	software, its quality, accuracy, merchantability, or fitness for a 
	*	particular purpose. As a result, this software is provided "as is," 
	*	and you, its user, are assuming the entire risk as to its quality 
	*	and accuracy.
*
*	Copyright (c) 1988-1993 by Apple Computer, Inc 
*		All Rights Reserved.
*
* $Header: /u/eng/malcolm/Speech/NewMacEar/RCS/UPortableIo.c,v 1.1 1992/12/11 18:16:05 malcolm Exp malcolm $ *
* $Log: UPortableIo.c,v $
* Revision 1.1 1992/12/11 18:16:05 malcolm * Initial revision
*
*/
/* Copyright (C) 1988-1991 Apple Computer, Inc. 
* All Rights Reserved.
*
* Warranty Information
* Even though Apple has reviewed this software, Apple makes no warranty 
* or representation, either express or implied, with respect to this 
* software, its quality, accuracy, merchantability, or fitness for a 
* particular purpose. As a result, this software is provided "as is," 
* and you, its user, are assuming the entire risk as to its quality 
* and accuracy.
*
* This code may be used and freely distributed as long as it includes 
* this copyright notice and the warranty information. 
*
* Machine-independent I/O routines for 8-, 16-, 24-, and 32-bit integers. 
*
* Motorola processors (Macintosh, Sun, Sparc, MIPS, etc) 
* pack bytes from high to low (they are big-endian). 
* Use the HighLow routines to match the native format 
* of these machines.
*
* Intel-like machines (PCs, Sequent)
* pack bytes from low to high (the are little-endian). 
* Use the LowHigh routines to match the native format 
* of these machines.
*
* These routines have been tested on the following machines: 
*	Apple Macintosh, MPW 3.1 C compiler
*	Apple Macintosh, THINK C compiler
*	Silicon Graphics IRIS, MIPS compiler
*	Cray X/MP and Y/MP
*	Digital Equipment VAX
*
*
* Implemented by Malcolm Slaney and Ken Turkowski. 
*
* Malcolm Slaney contributions during 1988-1990 include big- and little- 
* endian file I/O, conversion to and from Motorola's extended 80-bit 
* floating-point format, and conversions to and from IEEE single- 
* precision floating-point format.
*
* In 1991, Ken Turkowski implemented the conversions to and from 
* IEEE double-precision format, added more precision to the extended 
* conversions, and accommodated conversions involving +/- infinity, 
* NaN's, and denormalized numbers.
*/

/******************************************************************************/
/*************************** Constant Definitions *****************************/
/******************************************************************************/

#define	kFloatLength	sizeof(float)
#define	kDoubleLength	sizeof(double)
#define kExtendedLength	10				/* Try this value from old code. */

/******************************************************************************/
/*************************** Type definitions *********************************/
/******************************************************************************/

typedef	 short	int16;

typedef  long	int32;

/******************************************************************************/
/*************************** Macro Definitions ********************************/
/******************************************************************************/

/******************************************************************************/
/*************************** Subroutine declarations **************************/
/******************************************************************************/

void		ReadBytes(FILE *fp, char *p, int n);

void		ReadBytesSwapped(FILE	 *fp, char	 *p, int	 n);

void		Write16BitsHighLow(FILE *fp, int16 i);

void		Write16BitsLowHigh(FILE *fp, int16 i);

void		Write32Bits(FILE *fp, int32 i);

void		Write32BitsHighLow(FILE *fp, int32 i);

void		Write32BitsLowHigh(FILE *fp, int32 i);

void		Write8Bits(FILE *fp, int i);

void		WriteBytes(FILE	 *fp, char	 *p, int	 n);

void		WriteBytesSwapped(FILE	 *fp, char	 *p, int	 n);

void		WriteIeeeDoubleHighLow(FILE *fp, DefDouble num);

void		WriteIeeeDoubleLowHigh(FILE *fp, DefDouble num);

void		WriteIeeeExtendedHighLow(FILE *fp, DefDouble num);

void		WriteIeeeExtendedLowHigh(FILE *fp, DefDouble num);

void		WriteIeeeFloatHighLow(FILE *fp, DefDouble num);

void		WriteIeeeFloatLowHigh(FILE *fp, DefDouble num);

int16		Read16BitsLowHigh(FILE *fp);

int16		Read16BitsHighLow(FILE *fp);

int32		Read24BitsHighLow(FILE *fp);

int32		Read32BitsHighLow(FILE *fp);

int32		Read32BitsLowHigh(FILE *fp);

int			ReadByte(FILE *fp);

DefDouble	ReadIeeeDoubleHighLow(FILE *fp);

DefDouble	ReadIeeeDoubleLowHigh(FILE *fp);

DefDouble	ReadIeeeExtendedHighLow(FILE *fp);

DefDouble	ReadIeeeExtendedLowHigh(FILE *fp);

DefDouble	ReadIeeeFloatHighLow(FILE *fp);

DefDouble	ReadIeeeFloatLowHigh(FILE *fp);

#endif
